function [Forward, Backward, MeanVector, EValues] = TrainingPCA(Data)

[NumPtns, OutputSize] = size(Data);
MeanVector = mean(Data,1);
for i=1:NumPtns
    Data(i,:) = Data(i,:)-MeanVector;
end
Cov = cov(Data);
[evecs,evals] = eig(Cov);
evals = diag(evals)';

if OutputSize > 1
    if evals(1)<evals(end)
        evecs = fliplr(evecs);
        evals = fliplr(evals);
    else
        display('ho.');
    end
end

Forward = evecs';
Backward = Forward';
EValues = evals;
