function [K] = ComputeGaussianKernel(Input, rbf_var, Base)

if nargin < 3
    [NumTrnPtns,TrnInputSize] = size(Input);
    K = zeros(NumTrnPtns,NumTrnPtns);
    DistanceSq = zeros(1, NumTrnPtns);
    InnerProduct = zeros(1, NumTrnPtns);
    LineNormSq = sum(Input.^2,2)';
    for i=1:NumTrnPtns,
        PatternNormSq = LineNormSq(i);
        InnerProduct = Input(i,:)*Input';
        DistanceSq = abs(PatternNormSq+LineNormSq-2*InnerProduct);
        if rbf_var < 0
            rbf_var = mean(DistanceSq)*2;
        end
        K(i,:) = exp(-DistanceSq/rbf_var);
    end
else
    [NumTrnPtns,TrnInputSize] = size(Input);
    [NumBasePtns,BaseSize] = size(Base);
    K = zeros(NumBasePtns,NumTrnPtns);
    DistanceSq = zeros(1, NumTrnPtns);
    InnerProduct = zeros(1, NumTrnPtns);
    InputNormSq = sum(Input.^2,2)';
    BaseNormSq = sum(Base.^2,2)';
    for i=1:NumBasePtns,
        PatternNormSq = BaseNormSq(i);
        InnerProduct = Base(i,:)*Input';
        DistanceSq = abs(PatternNormSq+InputNormSq-2*InnerProduct);
        if rbf_var < 0
            rbf_var = mean(DistanceSq)*2;
        end
        K(i,:) = exp(-DistanceSq/rbf_var);
    end
end
